// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;	// [JˉeԂւ̍Wϊ
float4x4 mWorld;
float4x4 mView;

float3 Light;		// ̎˂
float4 diffuse;		// ق̃}eA̐F
texture Tex;		// قø
texture ToonTex;	// ĩݸޗpø

float4 InkColor;	// g̐F
float InkSize;		// g̃TCY

float4 vFog;		// tHO
float4 vEye;		// _

//==============================================================
// eNX`Tv
// قø
sampler MeshSmp=sampler_state 
{
	Texture=<Tex>;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	MipFilter=LINEAR;

};

// ĩݸޗpø
sampler ToonSmp=sampler_state 
{
	Texture=<ToonTex>;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	MipFilter=LINEAR;

	AddressU =clamp;

};

// -------------------------------------------------------------
// قø̏ꍇ
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct TexVS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 Col  : COLOR0;
    float2 Tex : TEXCOORD0;
    float2 ToonUV : TEXCOORD1;
    float  Fog		: FOG;
};

// -------------------------------------------------------------
// قø̏ꍇ̒_VF[_vO
// -------------------------------------------------------------
TexVS_OUTPUT TexToonVS(
      float4 vPos    : POSITION,          // f̒_
      float3 Normal : NORMAL,	         // f̖@
      float2 Tex : TEXCOORD0
){
    TexVS_OUTPUT Out = (TexVS_OUTPUT)0;        // o̓f[^

    Out.Pos = mul(vPos, mWVP);			 // Wϊ
    Out.Tex = Tex;

    float4 amb     = { 0.1f, 0.1f, 0.1f, 1.0f};

    float3 w_normal=normalize(mul(Normal, (float3x3)mWorld));  
    Out.ToonUV.x =  max(0, dot(w_normal,-Light)) + amb; 
    Out.ToonUV.y =  0.5;
    
    // tHO
    float4 pos = vPos - vEye;
    Out.Fog = vFog.x + length(pos) * vFog.y;

    return Out;
}
// -------------------------------------------------------------
// قø̏ꍇ̃sNZVF[_vO
// -------------------------------------------------------------
float4 TexToonPS(TexVS_OUTPUT In) : COLOR
{
	return tex2D(MeshSmp,In.Tex)*
		   tex2D(ToonSmp,In.ToonUV)*diffuse;
}



// -------------------------------------------------------------
// قøȂ̏ꍇ
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct MatVS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 Col  : COLOR0;
    float2 ToonUV : TEXCOORD1;
    float  Fog		: FOG;
};

// -------------------------------------------------------------
// قøȂ̏ꍇ̒_VF[_vO
// -------------------------------------------------------------
MatVS_OUTPUT MatToonVS(
      float4 vPos    : POSITION,          // f̒_
      float3 Normal : NORMAL	         // f̖@
){
    MatVS_OUTPUT Out = (MatVS_OUTPUT)0;        // o̓f[^

    Out.Pos = mul(vPos, mWVP);			 // Wϊ

    float4 amb     = { 0.1f, 0.1f, 0.1f, 1.0f};

    Out.Col =  max( dot(-Light, Normal), 1) + amb; 

    float3 w_normal=normalize(mul(Normal, (float3x3)mWorld));  
   
    Out.ToonUV.x =  max(0, dot(w_normal,-Light)) + amb; 
    Out.ToonUV.y =  0.5;
    
    // tHO
    float4 pos = vPos - vEye;
    Out.Fog = vFog.x + length(pos) * vFog.y;

    return Out;
}
// -------------------------------------------------------------
// قøȂ̏ꍇ̃sNZVF[_vO
// -------------------------------------------------------------
float4 MatToonPS(MatVS_OUTPUT In,
    float4 Col  : COLOR0 ) : COLOR
{
	return tex2D(ToonSmp,In.ToonUV)*Col*diffuse;
}

//----------------------------------------------
// g̒_VF[_
//----------------------------------------------
void ToonInkVS (
	float4 vPos : POSITION,
	float3 Normal : NORMAL,
	out float4 Pos : POSITION,
	out float oFog : FOG
) {
	// _W
	float4 wvp_pos=mul(vPos, mWVP);
	float4 wvp_normal=float4(mul(Normal, (float3x3)mWVP), 0);
	Pos=wvp_pos+normalize(wvp_normal)*InkSize*wvp_pos.w;
	// tHO
	float4 pos = vPos - vEye;
	oFog = vFog.x + length(pos) * vFog.y;
	
}

//----------------------------------------------
// g̃sNZVF[_
//----------------------------------------------
float4 ToonInkPS() : COLOR {
	return InkColor;
}

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------

// øĩݸނøƯ
technique TShader
{
	pass P0
    	{
        	CullMode=CCW;
		VertexShader = compile vs_1_1 TexToonVS();
		PixelShader  = compile ps_2_0 TexToonPS();
	}
    	pass P1 {
		CullMode=CW;
		VertexShader=compile vs_1_1 ToonInkVS();
		PixelShader=compile ps_2_0 ToonInkPS();
	}
}

// øȂĩݸނøƯ
technique TShader2
{
	pass P0
    	{
        // VF[_
        	CullMode=CCW;
		VertexShader = compile vs_1_1 MatToonVS();
		PixelShader  = compile ps_2_0 MatToonPS();
	}
    	pass P1 {
		CullMode=CW;
		VertexShader=compile vs_1_1 ToonInkVS();
		PixelShader=compile ps_2_0 ToonInkPS();
	}
}